
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% master.m
% 6/1/01
% master file which calls everything else
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global Q;


x0 = [10 5]';
if x0(1)*x0(2) >= 0
  Q = 1;
else
  Q = 2;
end;

q = []; I = []; Y = [];	T = []; X0 = x0;			% bookkeeping
Tevent = [];
options = odeset('Events','on');
cols = ['r' 'b' 'm' 'c' 'k' 'g' 'y'];
t0 = 0;
tf= 0.5;

A1 = [-1 10; -100 -1];
A2 = [-1 100; -10 -1];

P1 = lyap(A1',eye(2,2));
P2 = lyap(A2',eye(2,2));

for i = 1:20;

  [t,y,te,ye,ie]=ode23('lec7Logic',[t0 tf],x0,options);
  N = length(t);
  if (abs(te-t0) < 1e-3)			% not staying in a mode long
    sprintf('Cycling too quickly')
    break; break;
  else 
    t0 = t(N);
  end;
   
						% all resets encoded here
  if ( Q==1 )
    Qnew = 2;					% (guard conditions in logic)
    x0 = y(N,:)';
  elseif ( Q==2 )
    Qnew = 1;					
    x0 = y(N,:)';
  else 
    Qnew = -1;					% a trick to break
  end;

  V1 = y(:,1).*y(:,1)*P1(1,1) + y(:,1).*y(:,2)*(P1(1,2)+P1(2,1)) +  y(:,2).*y(:,2)*P1(2,2);
  V2 = y(:,1).*y(:,1)*P2(1,1) + y(:,1).*y(:,2)*(P2(1,2)+P2(2,1)) +  y(:,2).*y(:,2)*P2(2,2);

  figure(gcf); hold on;
  color = cols(mod(i,length(cols-1))+1);

  if (Q==1)					% encode output and plotting
    figure(1)
    subplot(211)
    plot(t,y(:,1),'r');  hold on;
    plot(t,y(:,2),'r--');  hold on;

    subplot(212)
    semilogy(t,V1,'r');  hold on;
    semilogy(t,V2,'r-.');  hold on;

    figure(2)
    plot(y(:,1),y(:,2),'r');  hold on;

  elseif (Q==2)
    figure(1)
    subplot(211)
    plot(t,y(:,1),'b');  hold on;
    plot(t,y(:,2),'b--');  hold on;

    subplot(212)
    semilogy(t,V2,'b');  hold on;
    semilogy(t,V1,'b-.');  hold on;

    figure(2)
    plot(y(:,1),y(:,2),'b');  hold on;

  end;

  q = [q Q];					% bookkeeping
  I = [I i];
  Y = [Y; y];
  T = [T; t];

  if Qnew == -1
    break; break;
  elseif t0 == tf
    break; break;
  else
    Q = Qnew;
  end
  X0 = [X0 x0];

end;

x = Y(:,1);
v = Y(:,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1)
subplot(211)
title('Time history with switching')
legend('x_1','x_2');
ylabel('x(t)');

subplot(212)
ylabel('V(q,x)')
xlabel('t');
legend('Active mode','Inactive mode');

figure(2);
xlabel('x_1'); ylabel('x_2');
title('Phase plane plot');


